---
title: IDBFactory.cmp()
slug: Web/API/IDBFactory/cmp
tags:
  - API
  - Database
  - IDBFactory
  - IndexedDB
  - Method
  - Reference
  - Storage
  - cmp
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>cmp()</code></strong> method of the {{domxref("IDBFactory")}} interface compares two values as keys to determine equality and ordering for IndexedDB operations, such as storing and iterating.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<div class="note">
<p><strong>Note</strong>: Do not use this method for comparing arbitrary JavaScript values, because many JavaScript values are either not valid IndexedDB keys (booleans and objects, for example) or are treated as equivalent IndexedDB keys (for example, since IndexedDB ignores arrays with non-numeric properties and treats them as empty arrays, so any non-numeric arrays are treated as equivalent). This throws an exception if either of the values is not a valid key.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>result</em> = <em>indexedDB</em>.cmp(first, second);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>first</dt>
 <dd>The first key to compare.</dd>
 <dt>second</dt>
 <dd>The second key to compare.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An integer that indicates the result of the comparison; the table below lists the possible values and their meanings:</p>

<table class="standard-table" style="width: 434px;">
 <tbody>
  <tr>
   <th scope="col">Returned value</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td>-1</td>
   <td>1st key is less than the 2nd key</td>
  </tr>
  <tr>
   <td>0</td>
   <td>1st key is equal to the 2nd key</td>
  </tr>
  <tr>
   <td>1</td>
   <td>1st key is greater than the 2nd key</td>
  </tr>
 </tbody>
</table>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td><a href="/en-US/docs/DOM/DOMError"><code>DataError</code></a></td>
   <td>One of the supplied keys was not a valid key.</td>
  </tr>
 </thead>
</table>

<h2 id="Example">Example</h2>

<pre class="brush: js;highlight:[3]">var a = 1;
var b = 2;
var result = window.indexedDB.cmp(a, b);
console.log( "Comparison results: " + result );</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbfactory-cmp', 'cmp()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbfactory-cmp", "cmp()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBFactory.cmp")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
